#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.11 Project
#

#################################
# GLOBAL VARIABLES
#
global cmdl; 
global in; 
global op2; 
global out; 
global widget; 
    set widget() {.top17.ent18}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
#Version check
global tk_version;
if {$tk_version < 4.2} {
    puts "gsc needs Tcl7.6/Tk4.2 later version."
    exit
}
}

init $argc $argv


proc {aboutbox} {} {
tk_messageBox -icon info -type ok -title "About gsc 1.0.1" -message  "Ghostscript Controler.\n-Free software-\n Copyright (c) 1998 Cow Project Workshop"
}

proc {main} {argc argv} {
global cmdl; 
global in; 
global op1; 
global op2; 
global out; 
set out {gsc.out}
#Check mark
.top17.rad18 select
#Load Listbox
set opt {{bit} {bitrgb} {jpeg} {jpeggray} {pbm} {pbmraw} {pcxmono} {pcxgray} {pcx16} {pcx256}  {pgm} {pnm} {png16} {png256} {ppm} {psgray} {psmono} {pswrite} {tiff12nc} {tiff24nc} {tifflzw}  {bj10e} {bj200} {bjc600} {bjc800} {cdeskject} {cdjcolor} {cdjmono} {cdj550} {deskjet} {djet500}  {laserjet} {lj5mono} {lj5gray} {ljet2p} {ljet3} {ljet4} {ljetdith} {ljetplus} {uniprint} {pj}  {pjxl} {pjxl300} {pxlmono} {pxlcolor} {bj10v} {dmprt} {epag300} {epag600} {epag} {fmpr} {jj100} {lips3} {lips4} {lips4c} {lpb2030} {mjc180} {mjc360} {mjc720} {mj500c} {pr150} {tiffcrle} {tiffg3} {tiffg32d} {tiffg4}}
foreach i $opt {
 .top17.cpd18.01 insert end $i
}
#Binding Mouse button
bind .top17.cpd18.01 <ButtonRelease-1> {
 bell
 set opsel [.top17.cpd18.01 curselection]
 switch $opsel {
  0
   {set op2 {-sDEVICE=bit}}
  1
   {set op2 {-sDEVICE=bitrgb}}
  2
   {set op2 {-sDEVICE=jpeg}}
  3
   {set op2 {-sDEVICE=jpeggray}}
  4
   {set op2 {-sDEVICE=pbm}}
  5
   {set op2 {-sDEVICE=pbmraw}}
  6
   {set op2 {-sDEVICE=pcxmono}}
  7
   {set op2 {-sDEVICE=pcxgray}}
  8
   {set op2 {-sDEVICE=pcx16}}
  9
   {set op2 {-sDEVICE=pcx256}}
  10
   {set op2 {-sDEVICE=pgm}}
  11
   {set op2 {-sDEVICE=pnm}}
  12
   {set op2 {-sDEVICE=png16}}
  13
   {set op2 {-sDEVICE=png256}}
  14
   {set op2 {-sDEVICE=ppm}}
  15
   {set op2 {-sDEVICE=psgray}}
  16
   {set op2 {-sDEVICE=psmono}}
  17
   {set op2 {-sDEVICE=pswrite}}
  18
   {set op2 {-sDEVICE=tiff12nc}}
  19
   {set op2 {-sDEVICE=tiff24nc}}
  20
   {set op2 {-sDEVICE=tifflzw}}
  21
   {set op2 {-sDEVICE=bj10e}}
  22
   {set op2 {-sDEVICE=bj200}}
  23
   {set op2 {-sDEVICE=bjc600}}
  24
   {set op2 {-sDEVICE=bjc800}}
  25
   {set op2 {-sDEVICE=cdeskject}}
  26
   {set op2 {-sDEVICE=cdjcolor}}
  27
   {set op2 {-sDEVICE=cdjmono}}
  28
   {set op2 {-sDEVICE=cdj550}}
  29
   {set op2 {-sDEVICE=deskjet}}
  30
   {set op2 {-sDEVICE=djet500}}
  31
   {set op2 {-sDEVICE=laserjet}}
  32
   {set op2 {-sDEVICE=lj5mono}}
  33
   {set op2 {-sDEVICE=lj5gray}}
  34
   {set op2 {-sDEVICE=ljet2p}}
  35
   {set op2 {-sDEVICE=ljet3}}
  36
   {set op2 {-sDEVICE=ljet4}}
  37
   {set op2 {-sDEVICE=ljetdith}}
  38
   {set op2 {-sDEVICE=ljetplus}}
  39
   {set op2 {-sDEVICE=uniprint}}
  40
   {set op2 {-sDEVICE=pj}}
  41
   {set op2 {-sDEVICE=pjxl}}
  42
   {set op2 {-sDEVICE=pjxl300}}
  43
   {set op2 {-sDEVICE=pxlmono}}
  44
   {set op2 {-sDEVICE=pxlcolor}}
  45
   {set op2 {-sDEVICE=bj10v}}
  46
   {set op2 {-sDEVICE=dmprt}}
  47
   {set op2 {-sDEVICE=epag300}}
  48
   {set op2 {-sDEVICE=epag600}}
  49
   {set op2 {-sDEVICE=epag}}
  50
   {set op2 {-sDEVICE=fmpr}}
  51
   {set op2 {-sDEVICE=jj100}}
  52
   {set op2 {-sDEVICE=lips3}}
  53
   {set op2 {-sDEVICE=lips4}}
  54
   {set op2 {-sDEVICE=lips4c}}
  55
   {set op2 {-sDEVICE=lpb2030}}
  56
   {set op2 {-sDEVICE=mjc180}}
  57
   {set op2 {-sDEVICE=mjc360}}
  58
   {set op2 {-sDEVICE=mjc720}}
  59
   {set op2 {-sDEVICE=mj500c}}
  60
   {set op2 {-sDEVICE=pr150}}
  61
   {set op2 {-sDEVICE=tiffcrle}}
  62
   {set op2 {-sDEVICE=tiffg3}}
  63
   {set op2 {-sDEVICE=tiffg32d}}
  64
   {set op2 {-sDEVICE=tiffg4}}
 }
set cmdl [concat gs -dNOPAUSE $op1 $op2 $in -c quit]
}
}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 200x200+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "gsc.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #71d3f2 -cursor xterm 
    wm focusmodel $base passive
    wm geometry $base 433x249+66+206
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "gsc Ver.1.0.1"
    label $base.lab18 \
        -background #dbb8db \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -relief groove -text {gsc for tcl/tk} 
    message $base.mes19 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -justify center -padx 5 -pady 3 -relief sunken \
        -text {Ghostscript Controler  (C)1998Cow} -width 100 
    button $base.but21 \
        \
        -command {bell
set op1 [format "%s%s" {-sOutputFile=}  $out]
set cmdl [concat gs -dNOPAUSE $op1 $op2 $in -c quit]
set cmdlexe [concat exec $cmdl]
eval $cmdlexe} \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #000000 -padx 9 -pady 3 -text {Start Convert} 
    radiobutton $base.rad17 \
        \
        -command {bell
set op1 [format "%s%s" {-sOutputFile=}  $out]
set cmdl [concat gs -dNOPAUSE $op1 $op2 $in -c quit]} \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -relief raised -text lpr -value {\|lpr} -variable out 
    radiobutton $base.rad18 \
        \
        -command {bell
set op1 [format "%s%s" {-sOutputFile=}  $out]
set cmdl [concat gs -dNOPAUSE $op1 $op2 $in -c quit]} \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -relief raised -text file -value gsc.out -variable out 
    label $base.lab20 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -relief groove -text To 
    label $base.lab22 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -relief groove -text {Input File} 
    label $base.lab23 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -relief groove -text Device 
    entry $base.ent24 \
        -cursor fleur \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -textvariable op2 
    button $base.but17 \
        -command exit \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text Quit 
    entry $base.ent18 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -justify right -textvariable in 
    label $base.lab19 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -relief groove -text {Output File} 
    entry $base.ent20 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -justify right -textvariable out 
    entry $base.ent25 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -state disabled -textvariable cmdl 
    button $base.but18 \
        \
        -command {set types {
    {{All Files} * }
    {{Postscript Files} {.ps} }
    {{EPS Files} {.eps} }
}
set in [tk_getOpenFile -filetypes $types -title "Input File" -initialfile $in]
set op1 [format "%s%s" {-sOutputFile=}  $out]
set cmdl [concat gs -dNOPAUSE $op1 $op2 $in -c quit]} \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text browse 
    button $base.but20 \
        -command aboutbox \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text about 
    frame $base.cpd18 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    listbox $base.cpd18.01 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -height 91 \
        -width 34 -yscrollcommand {.top17.cpd18.03 set} 
    bind $base.cpd18.01 <ButtonRelease-1> {
        bell
 set opsel [.top17.cpd18.01 curselection]
 switch $opsel {
  0
   {set op2 {-sDEVICE=bit}}
  1
   {set op2 {-sDEVICE=bitrgb}}
  2
   {set op2 {-sDEVICE=jpeg}}
  3
   {set op2 {-sDEVICE=jpeggray}}
  4
   {set op2 {-sDEVICE=pbm}}
  5
   {set op2 {-sDEVICE=pbmraw}}
  6
   {set op2 {-sDEVICE=pcxmono}}
  7
   {set op2 {-sDEVICE=pcxgray}}
  8
   {set op2 {-sDEVICE=pcx16}}
  9
   {set op2 {-sDEVICE=pcx256}}
  10
   {set op2 {-sDEVICE=pgm}}
  11
   {set op2 {-sDEVICE=pnm}}
  12
   {set op2 {-sDEVICE=png16}}
  13
   {set op2 {-sDEVICE=png256}}
  14
   {set op2 {-sDEVICE=ppm}}
  15
   {set op2 {-sDEVICE=psgray}}
  16
   {set op2 {-sDEVICE=psmono}}
  17
   {set op2 {-sDEVICE=pswrite}}
  18
   {set op2 {-sDEVICE=tiff12nc}}
  19
   {set op2 {-sDEVICE=tiff24nc}}
  20
   {set op2 {-sDEVICE=tifflzw}}
  21
   {set op2 {-sDEVICE=bj10e}}
  22
   {set op2 {-sDEVICE=bj200}}
  23
   {set op2 {-sDEVICE=bjc600}}
  24
   {set op2 {-sDEVICE=bjc800}}
  25
   {set op2 {-sDEVICE=cdeskject}}
  26
   {set op2 {-sDEVICE=cdjcolor}}
  27
   {set op2 {-sDEVICE=cdjmono}}
  28
   {set op2 {-sDEVICE=cdj550}}
  29
   {set op2 {-sDEVICE=deskjet}}
  30
   {set op2 {-sDEVICE=djet500}}
  31
   {set op2 {-sDEVICE=laserjet}}
  32
   {set op2 {-sDEVICE=lj5mono}}
  33
   {set op2 {-sDEVICE=lj5gray}}
  34
   {set op2 {-sDEVICE=ljet2p}}
  35
   {set op2 {-sDEVICE=ljet3}}
  36
   {set op2 {-sDEVICE=ljet4}}
  37
   {set op2 {-sDEVICE=ljetdith}}
  38
   {set op2 {-sDEVICE=ljetplus}}
  39
   {set op2 {-sDEVICE=uniprint}}
  40
   {set op2 {-sDEVICE=pj}}
  41
   {set op2 {-sDEVICE=pjxl}}
  42
   {set op2 {-sDEVICE=pjxl300}}
  43
   {set op2 {-sDEVICE=pxlmono}}
  44
   {set op2 {-sDEVICE=pxlcolor}}
  45
   {set op2 {-sDEVICE=bj10v}}
  46
   {set op2 {-sDEVICE=dmprt}}
  47
   {set op2 {-sDEVICE=epag300}}
  48
   {set op2 {-sDEVICE=epag600}}
  49
   {set op2 {-sDEVICE=epag}}
  50
   {set op2 {-sDEVICE=fmpr}}
  51
   {set op2 {-sDEVICE=jj100}}
  52
   {set op2 {-sDEVICE=lips3}}
  53
   {set op2 {-sDEVICE=lips4}}
  54
   {set op2 {-sDEVICE=lips4c}}
  55
   {set op2 {-sDEVICE=lpb2030}}
  56
   {set op2 {-sDEVICE=mjc180}}
  57
   {set op2 {-sDEVICE=mjc360}}
  58
   {set op2 {-sDEVICE=mjc720}}
  59
   {set op2 {-sDEVICE=mj500c}}
  60
   {set op2 {-sDEVICE=pr150}}
  61
   {set op2 {-sDEVICE=tiffcrle}}
  62
   {set op2 {-sDEVICE=tiffg3}}
  63
   {set op2 {-sDEVICE=tiffg32d}}
  64
   {set op2 {-sDEVICE=tiffg4}}
 }
set cmdl [concat gs -dNOPAUSE $op1 $op2 $in -c quit]
    }
    bind $base.cpd18.01 <Double-Button-1> {
        bell
 set opsel [.top17.cpd18.01 curselection]
 switch $opsel {
  0
   {set op2 {}}
  1
   {set op2 {-c}}
  2
   {set op2 {-d}}
  3
   {set op2 {-r}}
  4
   {set op2 {-m}}
  5
   {set op2 {-l}}
  6
   {set op2 {-Z0}}
  7
   {set op2 {-X}}
  8
   {set op2 {-B0}}
  9
   {set op2 {-f}}
 }
set cmdl [concat nkf -O $op1 $op2 $in $out]
    }
    scrollbar $base.cpd18.03 \
        -borderwidth 1 -command {.top17.cpd18.01 yview} -orient vert \
        -width 10 
    button $base.but22 \
        \
        -command {set types {
    {{All Files} * }
    {{JPEG Files} {.jp*} }
    {{PCX Files} {.pcx} }
    {{Bit Files} {.bit} }
    {{PBM Files} {.pbm} }
    {{PGM Files} {.pgm} }
    {{PNG Files} {.png} }
    {{PPM Files} {.ppm} }
    {{PS Files} {.ps} }
    {{Tiff Files} {.tif*} }
    {{Bitmap Files} {.bmp} }
}
set out [tk_getSaveFile -filetypes $types -title "Output File" -initialfile $out]
set op1 [format "%s%s" {-sOutputFile=}  $out]
set cmdl [concat gs -dNOPAUSE $op1 $op2 $in -c quit]} \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* -padx 9 \
        -pady 3 -text browse 
    button $base.but19 \
        \
        -command {set gschk [concat exec gs -? > gscheck.tmp]
eval $gschk
set gschk [concat exec xterm -e less gscheck.tmp &]
eval $gschk} \
        -padx 9 -pady 3 -text {gs check} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab18 \
        -x 10 -y 15 -width 104 -height 21 -anchor nw -bordermode ignore 
    place $base.mes19 \
        -x 10 -y 40 -width 106 -height 71 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 325 -y 125 -width 100 -height 28 -anchor nw -bordermode ignore 
    place $base.rad17 \
        -x 35 -y 125 -anchor nw -bordermode ignore 
    place $base.rad18 \
        -x 35 -y 155 -anchor nw -bordermode ignore 
    place $base.lab20 \
        -x 10 -y 125 -anchor nw -bordermode ignore 
    place $base.lab22 \
        -x 125 -y 15 -anchor nw -bordermode ignore 
    place $base.lab23 \
        -x 90 -y 125 -anchor nw -bordermode ignore 
    place $base.ent24 \
        -x 140 -y 185 -width 180 -height 24 -anchor nw -bordermode ignore 
    place $base.but17 \
        -x 325 -y 185 -width 99 -height 28 -anchor nw -bordermode ignore 
    place $base.ent18 \
        -x 125 -y 40 -width 300 -height 24 -anchor nw -bordermode ignore 
    place $base.lab19 \
        -x 125 -y 70 -anchor nw -bordermode ignore 
    place $base.ent20 \
        -x 125 -y 95 -width 300 -height 24 -anchor nw -bordermode ignore 
    place $base.ent25 \
        -x 10 -y 215 -width 415 -height 24 -anchor nw -bordermode ignore 
    place $base.but18 \
        -x 365 -y 15 -width 60 -height 23 -anchor nw -bordermode ignore 
    place $base.but20 \
        -x 325 -y 155 -width 100 -height 28 -anchor nw -bordermode ignore 
    place $base.cpd18 \
        -x 140 -y 125 -width 180 -height 60 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd18 0 -weight 1
    grid rowconf $base.cpd18 0 -weight 1
    grid $base.cpd18.01 \
        -in .top17.cpd18 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd18.03 \
        -in .top17.cpd18 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but22 \
        -x 365 -y 70 -width 60 -height 23 -anchor nw -bordermode ignore 
    place $base.but19 \
        -x 10 -y 185 -width 83 -height 28 -anchor nw -bordermode ignore 
}

Window show .
Window show .top17

main $argc $argv
